Subject: Re: bug#60308: 30.0.50; Can't read some PDF files any more

From: Stephen Berman <[email-masked]>
Date: Fri, 06 Jan 2023 10:58:27 +0100

On Fri, 06 Jan 2023 08:40:13 +0200 Eli Zaretskii <[email-masked]> wrote:

>> Date: Thu, 05 Jan 2023 20:58:24 +0000
>> From: Gregory Heytings <[email-masked]>
>> cc: Ihor Radchenko <[email-masked]>, [email-masked],
>>     [email-masked]
>>
>> >>> I can't read this file with emacs -Q:
>> >>>
>> >>> https://gnu.support/files/tmp/2023-01-05/FR%20205.pdf
>> >>
>> >> I can reproduce on Emacs 30 and Emacs 29, but not on Emacs 28
>> >>
>> >> Recipe: emacs -Q /path/to/the/linked/downloaded/pdf
>> >>
>> >> Observed: empty buffer
>> >> Expected: PDF page is displayed
>> >
>> > Can someone bisect this, please?
>> >
>>
>> FTR, that file opens fine here, with Emacs 29 at ec172d748f, at
>> d2a9dae400, at a6bad4d60f, at c59b8dfefa... and with Emacs 28.
>
> Thanks.
>
> So maybe the problem is updates to libraries/executables we use for
> viewing PDF?  AFAIR, this is DocView, and it use Ghostscript and
> libpng?  Maybe both Jean and Ihor had their systems updated recently?

I see the problem in Emacs 29 and master, but not in Emacs 28, on the
same system, i.e. with the same image libraries.  When the bad display
appears, the following entry appears in *Messages*:

Error parsing SVG image: XML parse error: Error domain 1 code 68 on line
7393 column 18 of data: StartTag: invalid element name

This seems to comes from svg_load_image in image.c.  I started Emacs 29
with -Q in gdb after setting a breakpoint at svg_load_image, opened the
PDF file, hit the breakpoint and stepped through till the bad display
appeared.  The ouput of bt full is attached.  (I also ran Emacs 28 under
gdb with the same breakpoint, and there visiting the PDF file does not
hit the breakpoint.)

Steve Berman